#include <sourcemod>
#include <dhooks>

Handle hPrecacheModel = null;

new String:g_sPrecacheLogPath[256];

public Plugin:myinfo = 
{
	name = "PrecacheModelInfo",
	author = "backwards, base code adapted from Franc1sco franug's precacheLimiter",
	description = "",
	version = "1.0",
	url = "http://steamcommunity.com/id/mypassword"
};

public void OnPluginStart()
{
  	for(new i=0;;i++)
	{
		BuildPath(Path_SM, g_sPrecacheLogPath, sizeof(g_sPrecacheLogPath), "logs/precached_%d.log", i);
		if (!FileExists(g_sPrecacheLogPath))
			break;
	}
	
	Handle hGameConf;
	
	hGameConf = LoadGameConfigFile("precachelimit.games");
	if(hGameConf == INVALID_HANDLE)
		SetFailState("Gamedata file precachelimit.games.txt is missing.");
	
	int iOffset = GameConfGetOffset(hGameConf, "Precache");
	if(iOffset == -1)
	{
		SetFailState("Failed to find offset for Precache");
		delete hGameConf;
	}
	
	StartPrepSDKCall(SDKCall_Static);
	
	if(!PrepSDKCall_SetFromConf(hGameConf, SDKConf_Signature, "CreateInterface"))
	{
		SetFailState("Failed to get CreateInterface");
		delete hGameConf;
	}
	
	PrepSDKCall_AddParameter(SDKType_String, SDKPass_Pointer);
	PrepSDKCall_AddParameter(SDKType_PlainOldData, SDKPass_Pointer, VDECODE_FLAG_ALLOWNULL);
	PrepSDKCall_SetReturnInfo(SDKType_PlainOldData, SDKPass_Plain);
	
	char identifier[64];
	if(!GameConfGetKeyValue(hGameConf, "EngineInterface", identifier, sizeof(identifier)))
	{
		SetFailState("Failed to get engine identifier name");
		delete hGameConf;
	}
	
	Handle temp = EndPrepSDKCall();
	Address addr = SDKCall(temp, identifier, 0);
	
	delete hGameConf;
	delete temp;
	
	if(!addr)
		SetFailState("Failed to get engine ptr");
	
	hPrecacheModel = DHookCreate(iOffset, HookType_Raw, ReturnType_Int, ThisPointer_Ignore, Hook_PrecacheModel);
	DHookAddParam(hPrecacheModel, HookParamType_CharPtr);
	DHookAddParam(hPrecacheModel, HookParamType_Bool);
	DHookRaw(hPrecacheModel, false, addr);
}

void LogToFile_Faster(char message[2048])
{
	File file = OpenFile(g_sPrecacheLogPath, "a"); 
	if(file == null)
		return;
	
	file.WriteLine(message);
	delete file;
}

public MRESReturn Hook_PrecacheModel(Handle hReturn, Handle hParams) 
{
	char buffer[2048];
	DHookGetParamString(hParams, 1, buffer, 2048);
	LogToFile_Faster(buffer);
	
	return MRES_Ignored;
}